# Class: Image

## Phaser. Image

Create a new `Image` object. An Image is a light-weight object you can use to display anything that doesn't need physics or animation. It can still rotate, scale, crop and receive input events. This makes it perfect for logos, backgrounds, simple buttons and other non-Sprite graphics.

#### new Image(game, x, y, key, frame)

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `game` | Phaser.Game | A reference to the currently running game.
  `x` | number | The x coordinate of the Image. The coordinate is relative to any parent container this Image may be in.
  `y` | number | The y coordinate of the Image. The coordinate is relative to any parent container this Image may be in.
  `key` | string | Phaser.RenderTexture | Phaser.BitmapData | PIXI.Texture | The texture used by the Image during rendering. It can be a string which is a reference to the Cache entry, or an instance of a RenderTexture, BitmapData or PIXI.Texture.
  `frame` | string | number | If this Image is using part of a sprite sheet or texture atlas you can specify the exact frame to use by giving a string or numeric index.

  Source:
    - gameobjects/Image.js, line 20

### Members

#### angle

  Indicates the rotation of the Image, in degrees, from its original orientation. Values from 0 to 180 represent clockwise rotation; values from 0 to -180 represent counterclockwise rotation. Values outside this range are added to or subtracted from 360 to obtain a value within the range. For example, the statement player.angle = 450 is the same as player.angle = 90. If you wish to work in radians instead of degrees use the property Image.rotation instead. Working in radians is also a little faster as it doesn't have to convert the angle.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `angle` | number | The angle of this Image in degrees.

  Source:
    - gameobjects/Image.js, line 493

#### autoCull

  Should this Image be automatically culled if out of range of the camera? A culled sprite has its renderable property set to 'false'. Be advised this is quite an expensive operation, as it has to calculate the bounds of the object every frame, so only enable it if you really need it.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `autoCull` | boolean | A flag indicating if the Image should be automatically camera culled or not.

  Default Value:
    - false
  Source:
    - gameobjects/Image.js, line 96

#### cameraOffset

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `cameraOffset` | Phaser.Point | If this object is fixedToCamera then this stores the x/y offset that its drawn at, from the top-left of the camera view.

  Source:
    - gameobjects/Image.js, line 106

#### <readonly> deltaX

  Returns the delta x value. The difference between world.x now and in the previous step.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `deltaX` | number | The delta value. Positive if the motion was to the right, negative if to the left.

  Source:
    - gameobjects/Image.js, line 517

#### <readonly> deltaY

  Returns the delta y value. The difference between world.y now and in the previous step.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `deltaY` | number | The delta value. Positive if the motion was downwards, negative if upwards.

  Source:
    - gameobjects/Image.js, line 534

#### <readonly> deltaZ

  Returns the delta z value. The difference between rotation now and in the previous step.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `deltaZ` | number | The delta value.

  Source:
    - gameobjects/Image.js, line 551

#### destroyPhase

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `destroyPhase` | boolean | True if this object is currently being destroyed.

  Source:
    - gameobjects/Image.js, line 780

#### events

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `events` | Phaser.Events | The Events you can subscribe to that are dispatched when certain things happen on this Image or its components.

  Source:
    - gameobjects/Image.js, line 58

#### exists

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `exists` | boolean | If exists = false then the Image isn't updated by the core game loop.

  Default Value:
    - true
  Source:
    - gameobjects/Image.js, line 36

#### fixedToCamera

  An Image that is fixed to the camera uses its x/y coordinates as offsets from the top left of the camera. These are stored in Image.cameraOffset. Note that the cameraOffset values are in addition to any parent in the display list. So if this Image was in a Group that has x: 200, then this will be added to the cameraOffset.x

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `fixedToCamera` | boolean | Set to true to fix this Image to the Camera at its current world coordinates.

  Source:
    - gameobjects/Image.js, line 715

#### frame

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `frame` | number | Gets or sets the current frame index and updates the Texture for display.

  Source:
    - gameobjects/Image.js, line 602

#### frameName

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `frameName` | string | Gets or sets the current frame by name and updates the Texture for display.

  Source:
    - gameobjects/Image.js, line 631

#### game

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `game` | Phaser.Game | A reference to the currently running Game.

  Source:
    - gameobjects/Image.js, line 30

#### <readonly> inCamera

  Checks if the Image bounds are within the game camera, otherwise false if fully outside of it.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `inCamera` | boolean | True if the Image bounds is within the game camera, even if only partially. Otherwise false if fully outside of it.

  Source:
    - gameobjects/Image.js, line 585

#### input

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `input` | Phaser.InputHandler | null | The Input Handler for this object. Needs to be enabled with image.inputEnabled = true before you can use it.

  Source:
    - gameobjects/Image.js, line 101

#### inputEnabled

  By default an Image won't process any input events at all. By setting inputEnabled to true the Phaser.InputHandler is activated for this object and it will then start to process click/touch events and more.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `inputEnabled` | boolean | Set to true to allow this object to receive input events.

  Source:
    - gameobjects/Image.js, line 675

#### <readonly> inWorld

  Checks if the Image bounds are within the game world, otherwise false if fully outside of it.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `inWorld` | boolean | True if the Image bounds is within the game world, even if only partially. Otherwise false if fully outside of it.

  Source:
    - gameobjects/Image.js, line 568

#### key

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `key` | string | Phaser.RenderTexture | Phaser.BitmapData | PIXI.Texture | This is the image or texture used by the Image during rendering. It can be a string which is a reference to the Cache entry, or an instance of a RenderTexture, BitmapData or PIXI.Texture.

  Source:
    - gameobjects/Image.js, line 63

#### name

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `name` | string | The user defined name given to this Image.

  Source:
    - gameobjects/Image.js, line 42

#### <readonly> renderOrderID

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `renderOrderID` | number | The render order ID, reset every frame.

  Source:
    - gameobjects/Image.js, line 660

#### smoothed

  Enable or disable texture smoothing for this Image. Only works for bitmap/image textures. Smoothing is enabled by default.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `smoothed` | boolean | Set to true to smooth the texture of this Image, or false to disable smoothing (great for pixel art)

  Source:
    - gameobjects/Image.js, line 746

#### <readonly> type

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `type` | number | The const type of this object.

  Source:
    - gameobjects/Image.js, line 48

#### world

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `world` | Phaser.Point | The world coordinates of this Image. This differs from the x/y coordinates which are relative to the Images container.

  Source:
    - gameobjects/Image.js, line 86

#### z

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `z` | number | The z-depth value of this object within its Group (remember the World is a Group as well). No two objects in a Group can have the same z value.

  Source:
    - gameobjects/Image.js, line 53

### Methods

#### bringToTop() → {Phaser.Image}

  Brings the Image to the top of the display list it is a child of. Images that are members of a Phaser.Group are only bought to the top of that Group, not the entire display list.

  Source:
    - gameobjects/Image.js, line 474

  ##### Returns:

  This instance.

  Type
    Phaser.Image

#### crop(rect)

  Crop allows you to crop the texture used to display this Image. Cropping takes place from the top-left of the Image and can be modified in real-time by providing an updated rectangle object. The rectangle object given to this method can be either a Phaser.Rectangle or any object so long as it has public x, y, width and height properties. Please note that the rectangle object given is not duplicated by this method, but rather the Image uses a reference to the rectangle. Keep this in mind if assigning a rectangle in a for-loop, or when cleaning up for garbage collection.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `rect` | Phaser.Rectangle | object | The Rectangle to crop the Image to. Pass null or no parameters to clear a previously set crop rectangle.

  Source:
    - gameobjects/Image.js, line 285

#### destroy(destroyChildren)

  Destroys the Image. This removes it from its parent group, destroys the input, event and animation handlers if present and nulls its reference to game, freeing it up for garbage collection.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `destroyChildren` | boolean | <optional> | true | Should every child of this object have its destroy method called?

  Source:
    - gameobjects/Image.js, line 384

#### kill() → {Phaser.Image}

  Kills a Image. A killed Image has its alive, exists and visible properties all set to false. It will dispatch the onKilled event, you can listen to Image.events.onKilled for the signal. Note that killing a Image is a way for you to quickly recycle it in a Image pool, it doesn't free it up from memory. If you don't need this Image any more you should call Image.destroy instead.

  Source:
    - gameobjects/Image.js, line 359

  ##### Returns:

  This instance.

  Type
    Phaser.Image

#### loadTexture(key, frame)

  Changes the Texture the Image is using entirely. The old texture is removed and the new one is referenced or fetched from the Cache. This causes a WebGL texture update, so use sparingly or in low-intensity portions of your game.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `key` | string | Phaser.RenderTexture | Phaser.BitmapData | PIXI.Texture | This is the image or texture used by the Image during rendering. It can be a string which is a reference to the Cache entry, or an instance of a RenderTexture, BitmapData or PIXI.Texture.
  `frame` | string | number | If this Image is using part of a sprite sheet or texture atlas you can specify the exact frame to use by giving a string or numeric index.

  Source:
    - gameobjects/Image.js, line 208

#### postUpdate()

  Internal function called by the World postUpdate cycle.

  Source:
    - gameobjects/Image.js, line 180

#### preUpdate()

  Automatically called by World.preUpdate.

  Source:
    - gameobjects/Image.js, line 129

#### reset(x, y) → {Phaser.Image}

  Resets the Image. This places the Image at the given x/y world coordinates and then sets alive, exists, visible and renderable all to true.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `x` | number | The x coordinate (in world space) to position the Image at.
  `y` | number | The y coordinate (in world space) to position the Image at.

  Source:
    - gameobjects/Image.js, line 451

  ##### Returns:

  This instance.

  Type
    Phaser.Image

#### revive() → {Phaser.Image}

  Brings a 'dead' Image back to life, optionally giving it the health value specified. A resurrected Image has its alive, exists and visible properties all set to true. It will dispatch the onRevived event, you can listen to Image.events.onRevived for the signal.

  Source:
    - gameobjects/Image.js, line 335

  ##### Returns:

  This instance.

  Type
    Phaser.Image

#### update()

  Override and use this function in your own custom objects to handle any update requirements you may have.

  Source:
    - gameobjects/Image.js, line 170